#pragma once

#include <vector>

namespace utils
{
class DriverWork
{
public:
    static void Install(LPCTSTR driverName,LPCTSTR driverExec,DWORD startType);
    static void Remove(LPCTSTR driverName,LPCTSTR driverExec);
    static void Start(LPCTSTR driverName);
    static void Stop(LPCTSTR driverName);
    static bool IsInstalled(LPCTSTR driverName);
    static bool IsLoaded(LPCTSTR driverName);

    static void Exchange(LPCTSTR driverName, 
                         unsigned long ioctlCode,
                         PWCHAR pInStr,
                         DWORD inStr_size,
                         PWCHAR pOutStr,
                         DWORD outStr_size,
                         PDWORD bytesReturned);

    static void ExchangeWithExceptionTranslation(
                         LPCTSTR driverName, 
                         unsigned long ioctlCode,
                         std::vector<char>* data);
};
}// namespace utils