#pragma once

#include "DirInfo.h"
#include "IEnvFileApi.h"

namespace utils
{

struct FileFindBuffer 
{
    DirInfo dirInfo;
    WCHAR names[MAX_PATH];
};

class FileFindApi
{
    IEnvFileApi* envApi_;
public:
    FileFindApi(IEnvFileApi* envApi)
        : envApi_(envApi)
    {}

    HANDLE FindFirstFile(const wchar_t* fileName,
                         FileFindBuffer* findFileData);

    BOOL FindNextFile(HANDLE hFindFile,
                      FileFindBuffer* findFileData);

    BOOL FindClose(HANDLE hFindFile);
};

}