#pragma once

#include "drvCommon.h"

namespace utils
{

struct IEnvFileApi
{
    virtual NTSTATUS Close(HANDLE handle)=0;
    virtual NTSTATUS OpenFile(PHANDLE FileHandle,
                              ACCESS_MASK DesiredAccess,
                              POBJECT_ATTRIBUTES ObjectAttributes,
                              PIO_STATUS_BLOCK IoStatusBlock,
                              ULONG ShareAccess,
                              ULONG OpenOptions)=0;

    virtual NTSTATUS QueryDirFile(HANDLE FileHandle,
                                  PIO_STATUS_BLOCK IoStatusBlock,
                                  PVOID FileInformation,
                                  ULONG Length,
                                  FILE_INFORMATION_CLASS FileInformationClass,
                                  BOOLEAN ReturnSingleEntry)=0;
};

}