#pragma once

#include "IEnvFileApi.h"

namespace utils
{

class ZwFileApi: public IEnvFileApi
{
public:
    NTSTATUS Close(HANDLE handle);
    NTSTATUS OpenFile(PHANDLE FileHandle,
                      ACCESS_MASK DesiredAccess,
                      POBJECT_ATTRIBUTES ObjectAttributes,
                      PIO_STATUS_BLOCK IoStatusBlock,
                      ULONG ShareAccess,
                      ULONG OpenOptions);

    NTSTATUS QueryDirFile(HANDLE FileHandle,
                          PIO_STATUS_BLOCK IoStatusBlock,
                          PVOID FileInformation,
                          ULONG Length,
                          FILE_INFORMATION_CLASS FileInformationClass,
                          BOOLEAN ReturnSingleEntry);
};

class NtFileApi: public IEnvFileApi
{
public:
    NTSTATUS Close(HANDLE handle);
    NTSTATUS OpenFile(PHANDLE FileHandle,
                      ACCESS_MASK DesiredAccess,
                      POBJECT_ATTRIBUTES ObjectAttributes,
                      PIO_STATUS_BLOCK IoStatusBlock,
                      ULONG ShareAccess,
                      ULONG OpenOptions);

    NTSTATUS QueryDirFile(HANDLE FileHandle,
                          PIO_STATUS_BLOCK IoStatusBlock,
                          PVOID FileInformation,
                          ULONG Length,
                          FILE_INFORMATION_CLASS FileInformationClass,
                          BOOLEAN ReturnSingleEntry);
};

}