#pragma once

#include "drvCommon.h"
#include <string>
namespace utils
{
inline UNICODE_STRING 
wstring2UnicodeStr(const std::wstring& str)
{
    UNICODE_STRING uncStr = {str.size()*2,str.size()*2,(PWCHAR)str.c_str()};
    return uncStr;
}
inline std::wstring
unicodeStr2wstring(PUNICODE_STRING strUS)
{
    if(strUS->Length == 0)
        throw std::exception("String can't be empty");

    wchar_t* strBegin = strUS->Buffer;
    wchar_t* strEnd = (wchar_t*)( (char*)strBegin + strUS->Length);
    
    return std::wstring(strBegin,strEnd);
}

inline UNICODE_STRING 
vector2UnicodeStr(const std::vector<char>& vect)
{
	if(vect.empty())
		throw std::exception("Vector can't be empty");

	UNICODE_STRING uncStr = {vect.size(),vect.size(),(PWCHAR)&vect[0]};
	return uncStr;
}

}