#pragma once
#include "ListForm.h"

class FileForm : public ListForm
{
    DECLARE_DYNCREATE(FileForm)

    bool isRunning_;
    ULONG totalCount_;

    CListCtrl* pListCtrl_;
protected:
	FileForm(); // protected constructor used by dynamic creation

private:
	void InitializeListCtrl(CListCtrl& listCtrl);
	void OnButtonClick(CListCtrl& listCtrl);

    void OnTimerImpl();
    void ConvertCountersToString(std::wstring* counters);

public:
    DECLARE_MESSAGE_MAP()
    afx_msg void OnTimer(UINT_PTR nIDEvent);
};