#pragma once
#include "afxcmn.h"
#include "resource.h"
// ListForm form view

#include <exception>
#include <string>

class ListForm : public CFormView
{
    DECLARE_DYNCREATE(ListForm)

	CListCtrl listCtrl_;
protected:
    ListForm();           // protected constructor used by dynamic creation
    virtual ~ListForm();

public:
    enum { IDD = IDD_LISTFORM };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    DECLARE_MESSAGE_MAP()
public:
    virtual void OnInitialUpdate();

protected:
	// Class can't be abstract because used DECLARE_DYNCREATE & IMPLEMENT_DYNCREATE
	virtual void InitializeListCtrl(CListCtrl& listCtrl){ThrowMustBeOvverided();}
	virtual void OnButtonClick(CListCtrl& listCtrl){ThrowMustBeOvverided();}

    void SetStatus(const std::wstring& status);

private:
	void ThrowMustBeOvverided(){throw std::exception("Class can't be used directly.");}


#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif
public:
    afx_msg void OnBnClickedButtonStartStop();
};


