#pragma once

#include "IEnvFileApi.h"

namespace utils
{

class CustomFileApi: public IEnvFileApi
{
    PVOID pClose_;
    PVOID pOpenFile_;
    PVOID pQueryDirFile_;
public:
    CustomFileApi(PVOID pClose,
                  PVOID pOpenFile,
                  PVOID pQueryDirFile)
        : pClose_(pClose)
        , pOpenFile_(pOpenFile)
        , pQueryDirFile_(pQueryDirFile)
    {}

    NTSTATUS Close(HANDLE handle);
    NTSTATUS OpenFile(PHANDLE FileHandle,
                      ACCESS_MASK DesiredAccess,
                      POBJECT_ATTRIBUTES ObjectAttributes,
                      PIO_STATUS_BLOCK IoStatusBlock,
                      ULONG ShareAccess,
                      ULONG OpenOptions);

    NTSTATUS QueryDirFile(HANDLE FileHandle,
                          PIO_STATUS_BLOCK IoStatusBlock,
                          PVOID FileInformation,
                          ULONG Length,
                          FILE_INFORMATION_CLASS FileInformationClass,
                          BOOLEAN ReturnSingleEntry);
};

}